# -*- coding: utf-8 -*-
from setuphelpers import *
import json

bin_name_x64 = "Regshot-x64-Unicode.exe"
bin_name_x86 = "Regshot-x86-Unicode.exe"

app_name = "Regshot"


def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()

    if isdir("Regshot"):
        remove_tree("Regshot")
    windows_release = json.loads(wgets("https://sourceforge.net/projects/regshot/best_release.json", proxies=proxies))["platform_releases"]["windows"]
    filename = windows_release["filename"].split("/")[-1]
    url_release = windows_release["url"]

    url_release = "https://sourceforge.net/projects/regshot/files/regshot/1.9.1-beta/Regshot-1.9.1-beta_r321.7z/download"
    filename = url_release.split("/")[-2]

    if not isfile(filename):
        wget(url_release, filename, proxies=proxies)

    path7z = makepath(programfiles, "7-Zip", "7z.exe")

    run('"%s" e %s -o%s' % (path7z, filename, app_name))

    if isfile(filename):
        remove_file(filename)

    version = get_file_properties(makepath(app_name, bin_name_x86))["ProductVersion"].split(" ")[0]

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Validating update-package-sources
    return result
